from observer import *
import time
import pigpio
import PPD42NS
import DHT22


class Info(Observer):
    def __init__(self, Push):
        Observer.__init__(Observer, Push)

    def run(self):
        while (True):
            item = self.popRQ()
            if (item != False):
                print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! inFo:  %s request %s" % (item.user, item.msg))
                g, r, c = self.Dust_Run()
                h, t = self.DHT_Run()
                result_msg = "\n -humidity : (%s)\n -temperate : (%s)\n -Dust concentrate : (%s)\n" % (h, t, c)
                self.mPush.insertMSG("-----------------inFo thread : \n---%s---" % result_msg)
                #123

            if (True):
                time.sleep(2)
                g, r, c = self.Dust_Run()
                h, t = self.DHT_Run()
                if t > 70 or t > 35 or c > 1000:
                    result_msg = "\n -humidity : (%s)\n -temperate : (%s)\n -Dust concentrate : (%s)\n" % (h, t, c)
                    self.mPush.insertMSG("-----------------inFo thread : ()")
                

        
    
    def Dust_Run(self):
        pi = pigpio.pi()
        s = PPD42NS.sensor(pi, 23)
        g, r, c = s.read()
        while True:
            time.sleep(1) # Use 30 for a properly calibrated reading.
            g, r, c = s.read()
            if c > 0 and c < 100000:
                break
        pi.stop()
        return g, r, c
        #msg = "gpio={" + g + "} ratio={" + r + "} conc={" + int(c) + "} pcs per 0.01 cubic foot"
        
        #self.mPush.insertMSG("gpio={} ratio={:.1f} conc={} pcs per 0.01 cubic foot".format(g, r, int(c)))
        #return g, r, c


    def DHT_Run(self):
        INTERVAL = 3
        pi = pigpio.pi()
        s = DHT22.sensor(pi, 22)
        r = 0
        next_reading = time.time()
        while True:
            r += 1
            s.trigger()
            time.sleep(0.2)
            h = s.humidity()
            t = s.temperature()
            #print("{} {} {} {:3.2f} {} {} {} {}".format(r, s.humidity(), s.temperature(), s.staleness(),s.bad_checksum(), s.short_message(), s.missing_message(), s.sensor_resets()))
            next_reading += INTERVAL
            time.sleep(next_reading - time.time())  # Overall INTERVAL second polling.
            if h > -100 and t > -100:
                break
            
        s.cancel()
        pi.stop()
        #self.mPush.insertMSG("H : {" + h + "}  T : {" + t + "}")
        return s.humidity(), s.temperature()



