from observer import *
import cv2
import numpy as np
import time

class Vi(Observer):
    BREAK_AWAY = ""
    RETURN_BACK = ""
    UNTILL_BREAK = ""
    frame = 0
    my_contours = []
    st_frame = 0
    out_frame = 0
    sz_frame = 0
    os_frame = 0
    ob_frame = 0
    sz_size = 0
    cap = 0
    vi_width = 0
    vi_height = 0
    contours = []
    edges = []
    mx = 0
    my = 0
    sz_x = 0
    sz_y = 0
    sz_w = 0
    sz_h = 0
    def __init__(self,Push):
        Observer.__init__(Observer,Push)
        self.BREAK_AWAY = "Baby is Zone out"
        self.RETURN_BACK = "Baby is Zone in"
        self.UNTILL_BREAK = "Baby is Zone out long time"
        self.mPush = Push
        self.frame = 0
        self.my_contours = []
        self.st_frame = 0
        self.out_frame = 0
        self.sz_frame = 15
        self.os_frame = 10
        self.ob_frame = 1
        self.sz_size = 100
        self.cap = 0
        self.vi_width = 0
        self.vi_height = 0
        self.contours = []
        self.edges = []
        self.mx = 0
        self.my = 0
        self.sz_x = 0
        self.sz_y = 0
        self.sz_w = 0
        self.sz_h = 0
        self.openCamera()
        # self.run()

    def out(self):
        if self.mx > self.sz_x and self.mx < self.sz_x + self.sz_w and self.my > self.sz_y and self.my < self.sz_y + self.sz_h:
            return 0
        else:
            return 1

    def openCamera(self):
        self.cap = cv2.VideoCapture('test2.mp4')
        self.vi_width = int(self.cap.get(cv2.CAP_PROP_FRAME_WIDTH))
        self.vi_height = int(self.cap.get(cv2.CAP_PROP_FRAME_HEIGHT))

    def getCapture(self):
        ret, self.frame = self.cap.read()
        if self.frame is None: return;
        frgray = cv2.cvtColor(self.frame, cv2.COLOR_BGR2GRAY)
        kernel = np.ones((3, 3), np.float32) / 25
        dst = cv2.filter2D(frgray, -1, kernel)
        self.edges = cv2.Canny(dst, 50, 100)
        _, self.contours, _ = cv2.findContours(self.edges, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)

    def getMoment(self):

        max_area = 0;
        ci = 0
        for i in range(len(self.contours)):
            cnt = self.contours[i]
            area = cv2.contourArea(cnt)
            if (area > max_area):
                max_area = area
                ci = i
        contours = self.contours[ci]
        mmt = cv2.moments(contours)
        if mmt['m00'] != 0:
            self.mx = int(mmt['m10'] / mmt['m00'])
            self.my = int(mmt['m01'] / mmt['m00'])
        cv2.rectangle(self.frame, (int(self.mx), int(self.my)), (int(self.mx), int(self.my)), (0, 0, 255), 8)
        if self.frame is None: return;
        # cv2.imshow('fgmask', self.frame)
        # cv2.imshow('EDGES', self.edges)

    def getSaftyZone(self):

        for i in range(0, self.vi_width):
            for j in range(0, self.vi_height):
                if self.edges[j, i] == 0:
                    self.edges[j, i] = 255
                else:
                    self.edges[j, i] = 0
                    self.my_contours.append([i, j])
        B = np.array(self.my_contours)
        self.sz_x, self.sz_y, self.sz_w, self.sz_h = cv2.boundingRect(B)
        self.setSafttyZoneSize()
        cv2.rectangle(self.frame, (int(self.sz_x), int(self.sz_y)),
                      (int(self.sz_x + self.sz_w), int(self.sz_y + self.sz_h)), (0, 0, 255), 3)

    def setSafttyZoneSize(self):

        tmp_rx = self.sz_x
        tmp_ry = self.sz_y
        self.sz_x = tmp_rx + int((100 - self.sz_size) / 200 * self.sz_w)
        self.sz_y = tmp_ry + int((100 - self.sz_size) / 200 * self.sz_h)
        self.sz_w = self.sz_size / 100 * self.sz_w
        self.sz_h = self.sz_size / 100 * self.sz_h

    def checkSaftyZone(self):

        if self.out() == 1:
            self.out_frame = self.out_frame + 1
        else:
            if self.out_frame > 30:
                self.out_frame = 0
                return (self.RETURN_BACK)
        if self.out_frame == 30:
            return (self.BREAK_AWAY)
        if self.out_frame > 0 and self.out_frame % 100 == 0:
            return (self.UNTILL_BREAK)
        return 0;

    def checkObserveFrame(self):
        self.st_frame = self.st_frame + 1
        if self.st_frame < self.os_frame: return 1
        if self.st_frame != self.sz_frame:
            if self.st_frame % self.ob_frame != 0 and self.out_frame == 0:
                return 1
            if self.st_frame % 5 != 0:
                return 1
        return 0

    def run(self):
        while(True):
            item = self.popRQ()
            if (item != False):
                print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!vi:  %s request %s" % (item.user, item.msg))
                cv2.imshow("Captured Image", self.frame)


            if(True):
                print("running Vi")
                while (True):
                    if self.checkObserveFrame() == 1:
                        continue
                    self.getCapture()
                    self.getMoment()
                    if self.st_frame == self.sz_frame:
                        self.getSaftyZone()
                    MSG = self.checkSaftyZone()
                    if MSG != 0:
                        self.mPush.insertMSG(MSG)
                    k = cv2.waitKey(30) & 0xff
                    if k == 27:
                        break
                self.cap.release()
                cv2.destroyAllWindows()

                time.sleep(2)
                self.mPush.insertMSG("-----------------Vi thread")



