import threading
from Vi import *
from Vo import *
from Info import *

class Push():
    VI = 0
    VO = 1
    IF = 2

    def __init__(self):
        self.sem_using = threading.Semaphore(1) # 1명만 쓸것
        self.sem_emp = threading.Semaphore(0) # 처음 큐는 비어있음
        self.Q=[]
        self.observerList=[]
        self.thList = []
        self.setUpObserverList()
        self.setUpThread()
        self.PushTh=threading.Thread(target = self.run)

    def setUpObserverList(self):
        self.observerList.append(Vi(self))
        self.observerList.append(Vo(self))
        self.observerList.append(Info(self))

    def setUpThread(self):
        for ob in self.observerList:
            self.thList.append(threading.Thread(target=ob.run))

    def insertMSG(self,str):
        self.sem_using.acquire() # 사용을 알림
        self.Q.append(str)
        print("--------------------in 관측자[%s]삽입완료"%str)
        self.sem_using.release() # 다썻다 알림
        self.sem_emp.release() # 세마포어 값 증가, 비어있던 큐에 1개들어갓음 알림

    def getMSG(self):
        self.sem_emp.acquire() # 비어있으면 대기
        self.sem_using.acquire() # 쓴다고 알림
        msg =self.Q[0]
        del self.Q[0]
        self.sem_using.release() # 다
        return msg

    def startTh(self):
        for th in self.thList:
            th.start()
    def run(self):
        self.startTh()
        cunt= 0
        while(True):
            cunt +=1
            print("in 관찰자[%s]"%( self.getMSG()) )

            ##실제 이부분은 전혀다른 외부에서 요청이 올예정인데 테스트를 위해 추가
            if cunt%10 ==0:
                self.observerList[self.VI].insertRQ("Test","사진")
                self.observerList[self.VO].insertRQ("Test", "음성")
                self.observerList[self.IF].insertRQ("Test", "정보")


if __name__ == "__main__":
    p=Push()
    p.PushTh.start()